diff --git a/src/dosext/builtins/builtins.c b/src/dosext/builtins/builtins.c
index 96b7d2a722..93880e5b8b 100644
--- a/src/dosext/builtins/builtins.c
+++ b/src/dosext/builtins/builtins.c
@@ -324,7 +324,17 @@ static int is_valid_drive(int drv)
 
   pre_msdos();
 
-  HI(ax) = 0x36; // get free disk space
+  /* Get the DPB (physical drives only, but including unformatted) */
+  HI(ax) = 0x32;
+  LO(dx) = drv;
+  call_msdos();
+  if (LO(ax) == 0) {
+    post_msdos();
+    return 1;
+  }
+
+  /* Get free disk space (both physical and network, but not unformatted) */
+  HI(ax) = 0x36;
   LO(dx) = drv;
   call_msdos();
   ret = LWORD(eax);
